code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to env seg

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new2f:	cmp	ax,1510h		; device driver request?
	jne	start
	cmp	byte ptr es:[bx+2],84h	; play audio function?
	jne	start

	mov	byte ptr es:[bx+2],0	; change to init (does nothing)
	push	ax
	pushf				; call old handler to get status
	push	cs
	call	start
	pop	ax
	mov	byte ptr es:[bx+2],84h	; restore play audio function
	jc	err			; let handler deal with errors
	cmp	word ptr es:[bx+3],300h	; busy playing?
	clc
	je	exit
err:	pushf				; call old handler to play audio
	push	cs
	call	start
exit:	retf	2

init:	mov	ax,352fh		; create jump to old handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new2f		; install new handler
	mov	ah,25h
	int	21h

	mov	es,envseg		; free env seg
	mov	ah,49h
	int	21h

	mov	dx,0014h		; terminate leaving DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
